RSpec.describe 'Compute module' do
  let(:dummy_class) { Class.new { 
      include Compute
      attr_reader :num
      def initialize(num)
        @num = num
      end } }

  context 'having two objects with num attributes' do
    let(:first_arg) { dummy_class.new(25) }
    let(:second_arg) { dummy_class.new(5) }

    context 'adding two objects with +' do

      it 'returns new object' do
        expect(first_arg.send(:+,second_arg)).to be_a(dummy_class)
      end
      
      it 'stores sum in new object\'s num attribute' do
        expect((first_arg.send(:+,second_arg)).num).to eq(30)
      end
      
    end
    
    context 'subtracting two objects with -' do

      it 'returns new object' do
        expect(first_arg.send(:-,second_arg)).to be_a(dummy_class)
      end
      
      it 'stores difference in new object\'s num attribute' do
        expect((first_arg.send(:-,second_arg)).num).to eq(20)
      end
      
    end
    
    context 'multiplying two objects with *' do

      it 'returns new object' do
        expect(first_arg.send(:*,second_arg)).to be_a(dummy_class)
      end
      
      it 'stores product in new object\'s num attribute' do
        expect((first_arg.send(:*,second_arg)).num).to eq(125)
      end
      
    end
    
    context 'dividing two objects with /' do

      it 'returns new object' do
        expect(first_arg.send(:/,second_arg)).to be_a(dummy_class)
      end
      
      it 'stores quotien in new object\'s num attribute' do
        expect((first_arg.send(:/,second_arg)).num).to eq(5)
      end
    end
  end
  
  context 'having any object with num attribute' do
    let(:object) { dummy_class.new(-68) }

    it '#num_mod returns modulo from dividing num attribute absolute by given number' do
      expect(object.num_mod(10)).to eq(8)
    end
    
  end
  
end