RSpec.describe 'Translate module' do
  let(:dummy_class) { Class.new { 
      include Translate
      attr_reader :num
      def initialize(num)
        @num = num
      end } }
  
  
  context '#in_english, having any object with num attribute' do
    let(:limit_number) { 10**Translate::DIGITS_LIMIT }
    let(:within_limit_num) { rand(limit_number) }
    let(:positive_num_object) { dummy_class.new(within_limit_num) }
    let(:negative_num_object) { dummy_class.new(0-within_limit_num) }
    let(:overlimit_num) { rand(limit_number..10*limit_number) }
    let(:bad_object) { dummy_class.new(overlimit_num) }

    it 'returns nil when digits count of num is over limit set in over_limit? method' do
      expect(bad_object.in_english).to eq(nil)
    end
    
    it 'should add "minus-" when the num is negative' do
      expect(negative_num_object.in_english).to match(/^minus-/)
    end
    
    it 'shouldn\'t add "minus-" when the num is positive' do
      expect(positive_num_object.in_english).not_to match(/^minus-/)
    end
  end
  
end